; sprite_header struct members (see gfx/sprite_headers.asm)
	const_def
	const SPRITEHEADER_ADDR_LO ; 0
	const SPRITEHEADER_ADDR_HI ; 1
	const SPRITEHEADER_SIZE    ; 2
	const SPRITEHEADER_BANK    ; 3
	const SPRITEHEADER_TYPE    ; 4
	const SPRITEHEADER_PALETTE ; 5
NUM_SPRITEHEADER_FIELDS EQU const_value

; sprite types
const_value SET 1
	const WALKING_SPRITE  ; 1
	const STANDING_SPRITE ; 2
	const STILL_SPRITE    ; 3

; sprite palettes
	const_def
	const PAL_OW_RED    ; 0
	const PAL_OW_BLUE   ; 1
	const PAL_OW_GREEN  ; 2
	const PAL_OW_BROWN  ; 3
	const PAL_OW_PINK   ; 4
	const PAL_OW_SILVER ; 5
	const PAL_OW_TREE   ; 6
	const PAL_OW_ROCK   ; 7

; object_events set bit 3 so as not to use the sprite's default palette
const_value set (1 << 3)
	const PAL_NPC_RED    ; 8
	const PAL_NPC_BLUE   ; 9
	const PAL_NPC_GREEN  ; a
	const PAL_NPC_BROWN  ; b
	const PAL_NPC_PINK   ; c
	const PAL_NPC_SILVER ; d
	const PAL_NPC_TREE   ; e
	const PAL_NPC_ROCK   ; f

; SpriteMovementData indexes (see data/map_objects.asm)
	const_def
	const SPRITEMOVEDATA_00                   ; 00
	const SPRITEMOVEDATA_ITEM_TREE            ; 01
	const SPRITEMOVEDATA_WANDER               ; 02
	const SPRITEMOVEDATA_SPINRANDOM_SLOW      ; 03
	const SPRITEMOVEDATA_WALK_UP_DOWN         ; 04
	const SPRITEMOVEDATA_WALK_LEFT_RIGHT      ; 05
	const SPRITEMOVEDATA_STANDING_DOWN        ; 06
	const SPRITEMOVEDATA_STANDING_UP          ; 07
	const SPRITEMOVEDATA_STANDING_LEFT        ; 08
	const SPRITEMOVEDATA_STANDING_RIGHT       ; 09
	const SPRITEMOVEDATA_SPINRANDOM_FAST      ; 0a
	const SPRITEMOVEDATA_PLAYER               ; 0b
	const SPRITEMOVEDATA_0C                   ; 0c
	const SPRITEMOVEDATA_0D                   ; 0d
	const SPRITEMOVEDATA_0E                   ; 0e
	const SPRITEMOVEDATA_0F                   ; 0f
	const SPRITEMOVEDATA_10                   ; 10
	const SPRITEMOVEDATA_11                   ; 11
	const SPRITEMOVEDATA_12                   ; 12
	const SPRITEMOVEDATA_FOLLOWING            ; 13
	const SPRITEMOVEDATA_SCRIPTED             ; 14
	const SPRITEMOVEDATA_SNORLAX              ; 15
	const SPRITEMOVEDATA_POKEMON              ; 16
	const SPRITEMOVEDATA_SUDOWOODO            ; 17
	const SPRITEMOVEDATA_SMASHABLE_ROCK       ; 18
	const SPRITEMOVEDATA_STRENGTH_BOULDER     ; 19
	const SPRITEMOVEDATA_FOLLOWNOTEXACT       ; 1a
	const SPRITEMOVEDATA_SHADOW               ; 1b
	const SPRITEMOVEDATA_EMOTE                ; 1c
	const SPRITEMOVEDATA_SCREENSHAKE          ; 1d
	const SPRITEMOVEDATA_SPINCOUNTERCLOCKWISE ; 1e
	const SPRITEMOVEDATA_SPINCLOCKWISE        ; 1f
	const SPRITEMOVEDATA_20                   ; 20
	const SPRITEMOVEDATA_BIGDOLL              ; 21
	const SPRITEMOVEDATA_BOULDERDUST          ; 22
	const SPRITEMOVEDATA_GRASS                ; 23
	const SPRITEMOVEDATA_LAPRAS               ; 24
NUM_SPRITEMOVEDATA EQU const_value
SPRITEMOVEDATA_FIELDS EQU 6

; MapObjectMovementPattern.Pointers indexes (see engine/map_objects.asm)
	const_def
	const SPRITEMOVEFN_00                    ; 00
	const SPRITEMOVEFN_RANDOM_WALK_Y         ; 01
	const SPRITEMOVEFN_RANDOM_WALK_X         ; 02
	const SPRITEMOVEFN_RANDOM_WALK_XY        ; 03
	const SPRITEMOVEFN_SLOW_RANDOM_SPIN      ; 04
	const SPRITEMOVEFN_FAST_RANDOM_SPIN      ; 05
	const SPRITEMOVEFN_STANDING              ; 06
	const SPRITEMOVEFN_OBEY_DPAD             ; 07
	const SPRITEMOVEFN_08                    ; 08
	const SPRITEMOVEFN_09                    ; 09
	const SPRITEMOVEFN_0A                    ; 0a
	const SPRITEMOVEFN_0B                    ; 0b
	const SPRITEMOVEFN_0C                    ; 0c
	const SPRITEMOVEFN_0D                    ; 0d
	const SPRITEMOVEFN_0E                    ; 0e
	const SPRITEMOVEFN_FOLLOW                ; 0f
	const SPRITEMOVEFN_SCRIPTED              ; 10
	const SPRITEMOVEFN_STRENGTH              ; 11
	const SPRITEMOVEFN_FOLLOWNOTEXACT        ; 12
	const SPRITEMOVEFN_SHADOW                ; 13
	const SPRITEMOVEFN_EMOTE                 ; 14
	const SPRITEMOVEFN_BIG_SNORLAX           ; 15
	const SPRITEMOVEFN_BOUNCE                ; 16
	const SPRITEMOVEFN_SCREENSHAKE           ; 17
	const SPRITEMOVEFN_SPIN_CLOCKWISE        ; 18
	const SPRITEMOVEFN_SPIN_COUNTERCLOCKWISE ; 19
	const SPRITEMOVEFN_BOULDERDUST           ; 1a
	const SPRITEMOVEFN_GRASS                 ; 1b

; StepTypesJumptable indexes (see engine/map_objects.asm)
	const_def
	const STEP_TYPE_00              ; 00
	const STEP_TYPE_SLEEP           ; 01
	const STEP_TYPE_NPC_WALK        ; 02
	const STEP_TYPE_03              ; 03
	const STEP_TYPE_04              ; 04
	const STEP_TYPE_05              ; 05
	const STEP_TYPE_PLAYER_WALK     ; 06
	const STEP_TYPE_07              ; 07
	const STEP_TYPE_NPC_JUMP        ; 08
	const STEP_TYPE_PLAYER_JUMP     ; 09
	const STEP_TYPE_HALF_STEP       ; 0a
	const STEP_TYPE_BUMP            ; 0b
	const STEP_TYPE_TELEPORT_FROM   ; 0c
	const STEP_TYPE_TELEPORT_TO     ; 0d
	const STEP_TYPE_SKYFALL         ; 0e
	const STEP_TYPE_0F              ; 0f
	const STEP_TYPE_GOT_BITE        ; 10
	const STEP_TYPE_ROCK_SMASH      ; 11
	const STEP_TYPE_RETURN_DIG      ; 12
	const STEP_TYPE_TRACKING_OBJECT ; 13
	const STEP_TYPE_14              ; 14
	const STEP_TYPE_15              ; 15
	const STEP_TYPE_16              ; 16
	const STEP_TYPE_17              ; 17
	const STEP_TYPE_18              ; 18
	const STEP_TYPE_SKYFALL_TOP     ; 19

; ObjectActionPairPointers indexes (see engine/map_object_action.asm)
	const_def
	const OBJECT_ACTION_00           ; 00
	const OBJECT_ACTION_STAND        ; 01
	const OBJECT_ACTION_STEP         ; 02
	const OBJECT_ACTION_BUMP         ; 03
	const OBJECT_ACTION_SPIN         ; 04
	const OBJECT_ACTION_SPIN_FLICKER ; 05
	const OBJECT_ACTION_FISHING      ; 06
	const OBJECT_ACTION_SHADOW       ; 07
	const OBJECT_ACTION_EMOTE        ; 08
	const OBJECT_ACTION_BIG_SNORLAX  ; 09
	const OBJECT_ACTION_BOUNCE       ; 0a
	const OBJECT_ACTION_WEIRD_TREE   ; 0b
	const OBJECT_ACTION_BIG_LAPRAS   ; 0c
	const OBJECT_ACTION_BIG_DOLL     ; 0d
	const OBJECT_ACTION_BOULDER_DUST ; 0e
	const OBJECT_ACTION_GRASS_SHAKE  ; 0f
	const OBJECT_ACTION_SKYFALL      ; 10

; Facings indexes (see data/facings.asm)
	const_def
	const FACING_STEP_DOWN_0    ; 00
	const FACING_STEP_DOWN_1    ; 01
	const FACING_STEP_DOWN_2    ; 02
	const FACING_STEP_DOWN_3    ; 03
	const FACING_STEP_UP_0      ; 04
	const FACING_STEP_UP_1      ; 05
	const FACING_STEP_UP_2      ; 06
	const FACING_STEP_UP_3      ; 07
	const FACING_STEP_LEFT_0    ; 08
	const FACING_STEP_LEFT_1    ; 09
	const FACING_STEP_LEFT_2    ; 0a
	const FACING_STEP_LEFT_3    ; 0b
	const FACING_STEP_RIGHT_0   ; 0c
	const FACING_STEP_RIGHT_1   ; 0d
	const FACING_STEP_RIGHT_2   ; 0e
	const FACING_STEP_RIGHT_3   ; 0f
	const FACING_FISH_DOWN      ; 10
	const FACING_FISH_UP        ; 11
	const FACING_FISH_LEFT      ; 12
	const FACING_FISH_RIGHT     ; 13
	const FACING_EMOTE          ; 14
	const FACING_SHADOW         ; 15
	const FACING_BIG_DOLL_ASYM  ; 16
	const FACING_BIG_DOLL_SYM   ; 17
	const FACING_WEIRD_TREE_0   ; 18
	const FACING_WEIRD_TREE_1   ; 19
	const FACING_WEIRD_TREE_2   ; 1a
	const FACING_WEIRD_TREE_3   ; 1b
	const FACING_BOULDER_DUST_1 ; 1c
	const FACING_BOULDER_DUST_2 ; 1d
	const FACING_GRASS_1        ; 1e
	const FACING_GRASS_2        ; 1f

; sprite_anim_struct members (see macros/wram.asm)
	const_def
	const SPRITEANIMSTRUCT_INDEX           ; 0
	const SPRITEANIMSTRUCT_FRAMESET_ID     ; 1
	const SPRITEANIMSTRUCT_ANIM_SEQ_ID     ; 2
	const SPRITEANIMSTRUCT_TILE_ID         ; 3
	const SPRITEANIMSTRUCT_XCOORD          ; 4
	const SPRITEANIMSTRUCT_YCOORD          ; 5
	const SPRITEANIMSTRUCT_XOFFSET         ; 6
	const SPRITEANIMSTRUCT_YOFFSET         ; 7
	const SPRITEANIMSTRUCT_DURATION        ; 8
	const SPRITEANIMSTRUCT_DURATIONOFFSET  ; 9
	const SPRITEANIMSTRUCT_FRAME           ; a
	const SPRITEANIMSTRUCT_JUMPTABLE_INDEX ; b
	const SPRITEANIMSTRUCT_0C              ; c
	const SPRITEANIMSTRUCT_0D              ; d
	const SPRITEANIMSTRUCT_0E              ; e
	const SPRITEANIMSTRUCT_0F              ; f

; SpriteAnimSeqData indexes (see data/sprite_anim_seqs.asm)
	const_def
	const SPRITE_ANIM_INDEX_PARTY_MON               ; 00
	const SPRITE_ANIM_INDEX_GS_TITLE_TRAIL          ; 01
	const SPRITE_ANIM_INDEX_NAMING_SCREEN_CURSOR    ; 02
	const SPRITE_ANIM_INDEX_GAMEFREAK_LOGO          ; 03
	const SPRITE_ANIM_INDEX_GS_INTRO_STAR           ; 04
	const SPRITE_ANIM_INDEX_GS_INTRO_SPARKLE        ; 05
	const SPRITE_ANIM_INDEX_SLOTS_GOLEM             ; 06
	const SPRITE_ANIM_INDEX_SLOTS_CHANSEY           ; 07
	const SPRITE_ANIM_INDEX_SLOTS_EGG               ; 08
	const SPRITE_ANIM_INDEX_COMPOSE_MAIL_CURSOR     ; 09
	const SPRITE_ANIM_INDEX_RED_WALK                ; 0a
	const SPRITE_ANIM_INDEX_UNUSED_CURSOR           ; 0b
	const SPRITE_ANIM_INDEX_DUMMY_GAME              ; 0c
	const SPRITE_ANIM_INDEX_POKEGEAR_ARROW          ; 0d
	const SPRITE_ANIM_INDEX_TRADE_POKE_BALL         ; 0e
	const SPRITE_ANIM_INDEX_TRADE_POOF              ; 0f
	const SPRITE_ANIM_INDEX_TRADE_TUBE_BULGE        ; 10
	const SPRITE_ANIM_INDEX_TRADEMON_ICON           ; 11
	const SPRITE_ANIM_INDEX_TRADEMON_BUBBLE         ; 12
	const SPRITE_ANIM_INDEX_EVOLUTION_BALL_OF_LIGHT ; 13
	const SPRITE_ANIM_INDEX_RADIO_TUNING_KNOB       ; 14
	const SPRITE_ANIM_INDEX_MAGNET_TRAIN_RED        ; 15
	const SPRITE_ANIM_INDEX_LEAF                    ; 16
	const SPRITE_ANIM_INDEX_CUT_TREE                ; 17
	const SPRITE_ANIM_INDEX_FLY_LEAF                ; 18
	const SPRITE_ANIM_INDEX_EGG_CRACK               ; 19
	const SPRITE_ANIM_INDEX_1A                      ; 1a
	const SPRITE_ANIM_INDEX_HEADBUTT                ; 1b
	const SPRITE_ANIM_INDEX_EGG_HATCH               ; 1c
	const SPRITE_ANIM_INDEX_1D                      ; 1d
	const SPRITE_ANIM_INDEX_BLUE_WALK               ; 1e
	const SPRITE_ANIM_INDEX_MAGNET_TRAIN_BLUE       ; 1f
	const SPRITE_ANIM_INDEX_MOBILE_TRADE_SENT_BALL  ; 20
	const SPRITE_ANIM_INDEX_MOBILE_TRADE_OT_BALL    ; 21
	const SPRITE_ANIM_INDEX_MOBILE_22               ; 22
	const SPRITE_ANIM_INDEX_MOBILE_23               ; 23
	const SPRITE_ANIM_INDEX_MOBILE_24               ; 24
	const SPRITE_ANIM_INDEX_MOBILE_25               ; 25
	const SPRITE_ANIM_INDEX_INTRO_SUICUNE           ; 26
	const SPRITE_ANIM_INDEX_INTRO_PICHU             ; 27
	const SPRITE_ANIM_INDEX_INTRO_WOOPER            ; 28
	const SPRITE_ANIM_INDEX_INTRO_UNOWN             ; 29
	const SPRITE_ANIM_INDEX_INTRO_UNOWN_F           ; 2a
	const SPRITE_ANIM_INDEX_INTRO_SUICUNE_AWAY      ; 2b
	const SPRITE_ANIM_INDEX_CELEBI                  ; 2c

; DoAnimFrame.Jumptable indexes (see engine/sprite_anims.asm)
	const_def
	const SPRITE_ANIM_SEQ_NULL                 ; 00
	const SPRITE_ANIM_SEQ_PARTY_MON            ; 01
	const SPRITE_ANIM_SEQ_PARTY_MON_SWITCH     ; 02
	const SPRITE_ANIM_SEQ_PARTY_MON_SELECTED   ; 03
	const SPRITE_ANIM_SEQ_GS_TITLE_TRAIL       ; 04
	const SPRITE_ANIM_SEQ_NAMING_SCREEN_CURSOR ; 05
	const SPRITE_ANIM_SEQ_GAMEFREAK_LOGO       ; 06
	const SPRITE_ANIM_SEQ_GS_INTRO_STAR        ; 07
	const SPRITE_ANIM_SEQ_GS_INTRO_SPARKLE     ; 08
	const SPRITE_ANIM_SEQ_SLOTS_GOLEM          ; 09
	const SPRITE_ANIM_SEQ_SLOTS_CHANSEY        ; 0a
	const SPRITE_ANIM_SEQ_SLOTS_EGG            ; 0b
	const SPRITE_ANIM_SEQ_MAIL_CURSOR          ; 0c
	const SPRITE_ANIM_SEQ_FOR_UNUSED_CURSOR    ; 0d
	const SPRITE_ANIM_SEQ_DUMMY_GAME_CURSOR    ; 0e
	const SPRITE_ANIM_SEQ_POKEGEAR_ARROW       ; 0f
	const SPRITE_ANIM_SEQ_TRADE_POKE_BALL      ; 10
	const SPRITE_ANIM_SEQ_TRADE_TUBE_BULGE     ; 11
	const SPRITE_ANIM_SEQ_TRADEMON_IN_TUBE     ; 12
	const SPRITE_ANIM_SEQ_REVEAL_NEW_MON       ; 13
	const SPRITE_ANIM_SEQ_RADIO_TUNING_KNOB    ; 14
	const SPRITE_ANIM_SEQ_CUT_LEAVES           ; 15
	const SPRITE_ANIM_SEQ_FLY_FROM             ; 16
	const SPRITE_ANIM_SEQ_FLY_LEAF             ; 17
	const SPRITE_ANIM_SEQ_FLY_TO               ; 18
	const SPRITE_ANIM_SEQ_19                   ; 19
	const SPRITE_ANIM_SEQ_1A                   ; 1a
	const SPRITE_ANIM_SEQ_FOR_MOBILE_23        ; 1b
	const SPRITE_ANIM_SEQ_FOR_MOBILE_24        ; 1c
	const SPRITE_ANIM_SEQ_INTRO_SUICUNE        ; 1d
	const SPRITE_ANIM_SEQ_INTRO_PICHU_WOOPER   ; 1e
	const SPRITE_ANIM_SEQ_CELEBI               ; 1f
	const SPRITE_ANIM_SEQ_INTRO_UNOWN          ; 20
	const SPRITE_ANIM_SEQ_INTRO_UNOWN_F        ; 21
	const SPRITE_ANIM_SEQ_INTRO_SUICUNE_AWAY   ; 22

; SpriteAnimFrameData indexes (see data/sprite_anim_frames.asm)
	const_def
	const SPRITE_ANIM_FRAMESET_00
	const SPRITE_ANIM_FRAMESET_PARTY_MON ; 01
	const SPRITE_ANIM_FRAMESET_PARTY_MON_WITH_MAIL ; 02
	const SPRITE_ANIM_FRAMESET_PARTY_MON_WITH_ITEM ; 03
	const SPRITE_ANIM_FRAMESET_PARTY_MON_FAST ; 04
	const SPRITE_ANIM_FRAMESET_PARTY_MON_WITH_MAIL_FAST ; 05
	const SPRITE_ANIM_FRAMESET_PARTY_MON_WITH_ITEM_FAST ; 06
	const SPRITE_ANIM_FRAMESET_GS_TITLE_TRAIL ; 07
	const SPRITE_ANIM_FRAMESET_TEXT_ENTRY_CURSOR ; 08
	const SPRITE_ANIM_FRAMESET_09
	const SPRITE_ANIM_FRAMESET_GAMEFREAK_LOGO ; 0a
	const SPRITE_ANIM_FRAMESET_GS_INTRO_STAR ; 0b
	const SPRITE_ANIM_FRAMESET_GS_INTRO_SPARKLE ; 0c
	const SPRITE_ANIM_FRAMESET_SLOTS_GOLEM ; 0d
	const SPRITE_ANIM_FRAMESET_SLOTS_CHANSEY ; 0e
	const SPRITE_ANIM_FRAMESET_SLOTS_CHANSEY_2 ; 0f
	const SPRITE_ANIM_FRAMESET_SLOTS_EGG ; 10
	const SPRITE_ANIM_FRAMESET_RED_WALK ; 11
	const SPRITE_ANIM_FRAMESET_STILL_CURSOR ; 12
	const SPRITE_ANIM_FRAMESET_TRADE_POKE_BALL ; 13
	const SPRITE_ANIM_FRAMESET_TRADE_POKE_BALL_0 ; 14
	const SPRITE_ANIM_FRAMESET_TRADE_POOF ; 15
	const SPRITE_ANIM_FRAMESET_TRADE_TUBE_BULGE ; 16
	const SPRITE_ANIM_FRAMESET_TRADEMON_ICON ; 17
	const SPRITE_ANIM_FRAMESET_TRADEMON_BUBBLE ; 18
	const SPRITE_ANIM_FRAMESET_EVOLUTION_BALL_OF_LIGHT ; 19
	const SPRITE_ANIM_FRAMESET_RADIO_TUNING_KNOB ; 1a
	const SPRITE_ANIM_FRAMESET_MAGNET_TRAIN_RED ; 1b
	const SPRITE_ANIM_FRAMESET_1C
	const SPRITE_ANIM_FRAMESET_LEAF ; 1d
	const SPRITE_ANIM_FRAMESET_CUT_TREE ; 1e
	const SPRITE_ANIM_FRAMESET_EGG_CRACK ; 1f
	const SPRITE_ANIM_FRAMESET_EGG_HATCH ; 20
	const SPRITE_ANIM_FRAMESET_21
	const SPRITE_ANIM_FRAMESET_22
	const SPRITE_ANIM_FRAMESET_23
	const SPRITE_ANIM_FRAMESET_24
	const SPRITE_ANIM_FRAMESET_HEADBUTT ; 25
	const SPRITE_ANIM_FRAMESET_26
	const SPRITE_ANIM_FRAMESET_27
	const SPRITE_ANIM_FRAMESET_28
	const SPRITE_ANIM_FRAMESET_29
	const SPRITE_ANIM_FRAMESET_2A
	const SPRITE_ANIM_FRAMESET_2B
	const SPRITE_ANIM_FRAMESET_2C
	const SPRITE_ANIM_FRAMESET_BLUE_WALK ; 2d
	const SPRITE_ANIM_FRAMESET_MAGNET_TRAIN_BLUE ; 2e
	const SPRITE_ANIM_FRAMESET_MOBILE_TRADE_SENT_BALL ; 2f
	const SPRITE_ANIM_FRAMESET_MOBILE_TRADE_OT_BALL ; 30
	const SPRITE_ANIM_FRAMESET_FOR_MOBILE_22 ; 31
	const SPRITE_ANIM_FRAMESET_FOR_MOBILE_23 ; 32
	const SPRITE_ANIM_FRAMESET_FOR_MOBILE_24 ; 33
	const SPRITE_ANIM_FRAMESET_FOR_MOBILE_25 ; 34
	const SPRITE_ANIM_FRAMESET_INTRO_SUICUNE ; 35
	const SPRITE_ANIM_FRAMESET_INTRO_SUICUNE_2 ; 36
	const SPRITE_ANIM_FRAMESET_INTRO_PICHU ; 37
	const SPRITE_ANIM_FRAMESET_INTRO_WOOPER ; 38
	const SPRITE_ANIM_FRAMESET_INTRO_UNOWN_1 ; 39
	const SPRITE_ANIM_FRAMESET_INTRO_UNOWN_2 ; 3a
	const SPRITE_ANIM_FRAMESET_INTRO_UNOWN_3 ; 3b
	const SPRITE_ANIM_FRAMESET_INTRO_UNOWN_4 ; 3c
	const SPRITE_ANIM_FRAMESET_INTRO_UNOWN_F_2 ; 3d
	const SPRITE_ANIM_FRAMESET_INTRO_SUICUNE_AWAY ; 3e
	const SPRITE_ANIM_FRAMESET_INTRO_UNOWN_F ; 3f
	const SPRITE_ANIM_FRAMESET_CELEBI_LEFT ; 40
	const SPRITE_ANIM_FRAMESET_CELEBI_RIGHT ; 41

; SpriteAnimOAMData indexes (see data/sprite_anim_oam.asm)
	const_def
	const SPRITE_ANIM_FRAME_IDX_RED_WALK_1 ; 00
	const SPRITE_ANIM_FRAME_IDX_RED_WALK_2 ; 01
	const SPRITE_ANIM_FRAME_IDX_02
	const SPRITE_ANIM_FRAME_IDX_03
	const SPRITE_ANIM_FRAME_IDX_04
	const SPRITE_ANIM_FRAME_IDX_05
	const SPRITE_ANIM_FRAME_IDX_06
	const SPRITE_ANIM_FRAME_IDX_07
	const SPRITE_ANIM_FRAME_IDX_08
	const SPRITE_ANIM_FRAME_IDX_09
	const SPRITE_ANIM_FRAME_IDX_0A
	const SPRITE_ANIM_FRAME_IDX_0B
	const SPRITE_ANIM_FRAME_IDX_0C
	const SPRITE_ANIM_FRAME_IDX_0D
	const SPRITE_ANIM_FRAME_IDX_0E
	const SPRITE_ANIM_FRAME_IDX_0F
	const SPRITE_ANIM_FRAME_IDX_10
	const SPRITE_ANIM_FRAME_IDX_11
	const SPRITE_ANIM_FRAME_IDX_12
	const SPRITE_ANIM_FRAME_IDX_13
	const SPRITE_ANIM_FRAME_IDX_14
	const SPRITE_ANIM_FRAME_IDX_15
	const SPRITE_ANIM_FRAME_IDX_16
	const SPRITE_ANIM_FRAME_IDX_17
	const SPRITE_ANIM_FRAME_IDX_18
	const SPRITE_ANIM_FRAME_IDX_19
	const SPRITE_ANIM_FRAME_IDX_1A
	const SPRITE_ANIM_FRAME_IDX_1B
	const SPRITE_ANIM_FRAME_IDX_1C
	const SPRITE_ANIM_FRAME_IDX_1D
	const SPRITE_ANIM_FRAME_IDX_GS_TITLE_TRAIL_1 ; 1e
	const SPRITE_ANIM_FRAME_IDX_GS_TITLE_TRAIL_2 ; 1f
	const SPRITE_ANIM_FRAME_IDX_TEXT_ENTRY_CURSOR ; 20
	const SPRITE_ANIM_FRAME_IDX_FOR_FRAMESET_09 ; 21
	const SPRITE_ANIM_FRAME_IDX_22
	const SPRITE_ANIM_FRAME_IDX_GS_INTRO_STAR ; 23
	const SPRITE_ANIM_FRAME_IDX_GS_INTRO_SPARKLE_1 ; 24
	const SPRITE_ANIM_FRAME_IDX_GS_INTRO_SPARKLE_2 ; 25
	const SPRITE_ANIM_FRAME_IDX_GS_INTRO_SPARKLE_3 ; 26
	const SPRITE_ANIM_FRAME_IDX_SLOTS_GOLEM_1 ; 27
	const SPRITE_ANIM_FRAME_IDX_SLOTS_GOLEM_2 ; 28
	const SPRITE_ANIM_FRAME_IDX_SLOTS_CHANSEY_1 ; 29
	const SPRITE_ANIM_FRAME_IDX_SLOTS_CHANSEY_2 ; 2a
	const SPRITE_ANIM_FRAME_IDX_SLOTS_CHANSEY_3 ; 2b
	const SPRITE_ANIM_FRAME_IDX_SLOTS_CHANSEY_4 ; 2c
	const SPRITE_ANIM_FRAME_IDX_SLOTS_CHANSEY_5 ; 2d
	const SPRITE_ANIM_FRAME_IDX_SLOTS_EGG ; 2e
	const SPRITE_ANIM_FRAME_IDX_STILL_CURSOR ; 2f
	const SPRITE_ANIM_FRAME_IDX_TRADE_POKE_BALL_1 ; 30
	const SPRITE_ANIM_FRAME_IDX_TRADE_POKE_BALL_2 ; 31
	const SPRITE_ANIM_FRAME_IDX_TRADE_POOF_1 ; 32
	const SPRITE_ANIM_FRAME_IDX_TRADE_POOF_2 ; 33
	const SPRITE_ANIM_FRAME_IDX_TRADE_POOF_3 ; 34
	const SPRITE_ANIM_FRAME_IDX_35
	const SPRITE_ANIM_FRAME_IDX_36
	const SPRITE_ANIM_FRAME_IDX_TRADEMON_ICON_1 ; 37
	const SPRITE_ANIM_FRAME_IDX_TRADEMON_ICON_2 ; 38
	const SPRITE_ANIM_FRAME_IDX_TRADEMON_BUBBLE ; 39
	const SPRITE_ANIM_FRAME_IDX_EVOLUTION_BALL_OF_LIGHT_1 ; 3a
	const SPRITE_ANIM_FRAME_IDX_EVOLUTION_BALL_OF_LIGHT_2 ; 3b
	const SPRITE_ANIM_FRAME_IDX_RADIO_TUNING_KNOB ; 3c
	const SPRITE_ANIM_FRAME_IDX_PARTY_MON_WITH_MAIL_1 ; 3d
	const SPRITE_ANIM_FRAME_IDX_PARTY_MON_WITH_MAIL_2 ; 3e
	const SPRITE_ANIM_FRAME_IDX_PARTY_MON_WITH_ITEM_1 ; 3f
	const SPRITE_ANIM_FRAME_IDX_PARTY_MON_WITH_ITEM_2 ; 40
	const SPRITE_ANIM_FRAME_IDX_MAGNET_TRAIN_RED_1 ; 41
	const SPRITE_ANIM_FRAME_IDX_MAGNET_TRAIN_RED_2 ; 42
	const SPRITE_ANIM_FRAME_IDX_43
	const SPRITE_ANIM_FRAME_IDX_44
	const SPRITE_ANIM_FRAME_IDX_45
	const SPRITE_ANIM_FRAME_IDX_46
	const SPRITE_ANIM_FRAME_IDX_47
	const SPRITE_ANIM_FRAME_IDX_48
	const SPRITE_ANIM_FRAME_IDX_49
	const SPRITE_ANIM_FRAME_IDX_4A
	const SPRITE_ANIM_FRAME_IDX_4B
	const SPRITE_ANIM_FRAME_IDX_4C
	const SPRITE_ANIM_FRAME_IDX_4D
	const SPRITE_ANIM_FRAME_IDX_4E
	const SPRITE_ANIM_FRAME_IDX_LEAF ; 4f
	const SPRITE_ANIM_FRAME_IDX_TREE_1 ; 50
	const SPRITE_ANIM_FRAME_IDX_CUT_TREE_2 ; 51
	const SPRITE_ANIM_FRAME_IDX_CUT_TREE_3 ; 52
	const SPRITE_ANIM_FRAME_IDX_CUT_TREE_4 ; 53
	const SPRITE_ANIM_FRAME_IDX_EGG_CRACK ; 54
	const SPRITE_ANIM_FRAME_IDX_55
	const SPRITE_ANIM_FRAME_IDX_56
	const SPRITE_ANIM_FRAME_IDX_57
	const SPRITE_ANIM_FRAME_IDX_58
	const SPRITE_ANIM_FRAME_IDX_59
	const SPRITE_ANIM_FRAME_IDX_5A
	const SPRITE_ANIM_FRAME_IDX_HEADBUTT_TREE_2 ; 5b
	const SPRITE_ANIM_FRAME_IDX_5C
	const SPRITE_ANIM_FRAME_IDX_5D
	const SPRITE_ANIM_FRAME_IDX_5E
	const SPRITE_ANIM_FRAME_IDX_5F
	const SPRITE_ANIM_FRAME_IDX_60
	const SPRITE_ANIM_FRAME_IDX_61
	const SPRITE_ANIM_FRAME_IDX_62
	const SPRITE_ANIM_FRAME_IDX_BLUE_WALK_1 ; 63
	const SPRITE_ANIM_FRAME_IDX_BLUE_WALK_2 ; 64
	const SPRITE_ANIM_FRAME_IDX_MAGNET_TRAIN_BLUE_1 ; 65
	const SPRITE_ANIM_FRAME_IDX_MAGNET_TRAIN_BLUE_2 ; 66
	const SPRITE_ANIM_FRAME_IDX_FOR_MOBILE_22_1 ; 67
	const SPRITE_ANIM_FRAME_IDX_FOR_MOBILE_22_2 ; 68
	const SPRITE_ANIM_FRAME_IDX_FOR_MOBILE_25_1 ; 69
	const SPRITE_ANIM_FRAME_IDX_FOR_MOBILE_25_2 ; 6a
	const SPRITE_ANIM_FRAME_IDX_FOR_MOBILE_25_3 ; 6b
	const SPRITE_ANIM_FRAME_IDX_FOR_MOBILE_23 ; 6c
	const SPRITE_ANIM_FRAME_IDX_FOR_MOBILE_24 ; 6d
	const SPRITE_ANIM_FRAME_IDX_INTRO_SUICUNE_1 ; 6e
	const SPRITE_ANIM_FRAME_IDX_INTRO_SUICUNE_2 ; 6f
	const SPRITE_ANIM_FRAME_IDX_INTRO_SUICUNE_3 ; 70
	const SPRITE_ANIM_FRAME_IDX_INTRO_SUICUNE_4 ; 71
	const SPRITE_ANIM_FRAME_IDX_INTRO_PICHU_1 ; 72
	const SPRITE_ANIM_FRAME_IDX_INTRO_PICHU_2 ; 73
	const SPRITE_ANIM_FRAME_IDX_INTRO_PICHU_3 ; 74
	const SPRITE_ANIM_FRAME_IDX_INTRO_WOOPER ; 75
	const SPRITE_ANIM_FRAME_IDX_INTRO_UNOWN_1 ; 76
	const SPRITE_ANIM_FRAME_IDX_INTRO_UNOWN_2 ; 77
	const SPRITE_ANIM_FRAME_IDX_INTRO_UNOWN_3 ; 78
	const SPRITE_ANIM_FRAME_IDX_INTRO_UNOWN_F_2_1 ; 79
	const SPRITE_ANIM_FRAME_IDX_INTRO_UNOWN_F_2_2 ; 7a
	const SPRITE_ANIM_FRAME_IDX_INTRO_UNOWN_F_2_3 ; 7b
	const SPRITE_ANIM_FRAME_IDX_INTRO_UNOWN_F_2_4 ; 7c
	const SPRITE_ANIM_FRAME_IDX_INTRO_UNOWN_F_2_5 ; 7d
	const SPRITE_ANIM_FRAME_IDX_INTRO_SUICUNE_AWAY ; 7e
	const SPRITE_ANIM_FRAME_IDX_CELEBI_1 ; 7f
	const SPRITE_ANIM_FRAME_IDX_CELEBI_2 ; 80
	const SPRITE_ANIM_FRAME_IDX_GAMEFREAK_LOGO_1 ; 81
	const SPRITE_ANIM_FRAME_IDX_GAMEFREAK_LOGO_2 ; 82
	const SPRITE_ANIM_FRAME_IDX_GAMEFREAK_LOGO_3 ; 83
	const SPRITE_ANIM_FRAME_IDX_GAMEFREAK_LOGO_4 ; 84
	const SPRITE_ANIM_FRAME_IDX_GAMEFREAK_LOGO_5 ; 85
	const SPRITE_ANIM_FRAME_IDX_GAMEFREAK_LOGO_6 ; 86
	const SPRITE_ANIM_FRAME_IDX_GAMEFREAK_LOGO_7 ; 87
	const SPRITE_ANIM_FRAME_IDX_GAMEFREAK_LOGO_8 ; 88
	const SPRITE_ANIM_FRAME_IDX_GAMEFREAK_LOGO_9 ; 89
	const SPRITE_ANIM_FRAME_IDX_GAMEFREAK_LOGO_10 ; 8A
	const SPRITE_ANIM_FRAME_IDX_GAMEFREAK_LOGO_11 ; 8B
